/**
 * Created by Jervain on 2017/5/24.
 */

Object.isFalse = function (o) {
    return o === false;
};

Object.isUndefined = function (o) {
    return o === undefined;
};

Object.isNull = function (o) {
    return o === null;
};

Object.isTrue = function (o) {
    return o === true;
};

/**
 * 判断数据是否可用
 * 不可用的数据: false, null, undefined
 * @param o
 */
Object.isValid = function (o) {
    return !Object.isNull(o) && !Object.isFalse(o) && !Object.isUndefined(o);
};

Number.isNumber = function (o) {
    if (!Object.isValid(o)) {
        return false;
    }
    var rs = o === "";
    return !rs && !isNaN(o);
};


Number.isInteger = function (n) {
    if (Number.isNumber(n)) {
        n -= 0;
        return n%1 == 0;
    }
    return false;
};


/**
 * n1 == n2
 * @param n1
 * @param n2
 * @returns {boolean}
 */
Math.eq = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) === (n2-0);
    }
    return false;
};

/**
 * n1 != n2
 * @param n1
 * @param n2
 * @returns {boolean}
 */
Math.neq = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) !== (n2-0);
    }
    return false;
};


/**
 * n1 < n2
 * @param n1
 * @param n2
 */
Math.lt = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        n1 -= 0, n2 -= 0;
        return n1 < n2;
    }
    return false;
};


/**
 * n1 <= n2
 * @param n1
 * @param n2
 * @returns {boolean}
 */
Math.elt = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        n1 -= 0, n2 -= 0;
        return n1 <= n2;
    }
    return false;
};


/**
 * n1 > n2
 * @param n1
 * @param n2
 * @returns {boolean}
 */
Math.gt = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) > (n2-0);
    }
    return false;
};

/**
 * n1 >= n2
 * @param n1
 * @param n2
 */
Math.glt = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) >= (n2-0);
    }
    return false;
};

/**
 * n1 + n2
 * @param n1
 * @param n2
 * @returns {*}
 */
Math.plus = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) + (n2-0);
    }
    return null;
};


/**
 * n1 - n2
 * @param n1
 * @param n2
 * @returns {*}
 */
Math.minus = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) - (n2-0);
    }
    return null;
};

/**
 * n1 * n2
 * @param n1
 * @param n2
 * @returns {*}
 */
Math.multiply = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) * (n2-0);
    }
    return null;
};

/**
 * n1 / n2
 * @param n1
 * @param n2
 * @returns {*}
 */
Math.division = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) / (n2-0);
    }
    return null;
};

/**
 * n1 % n2
 * @param n1
 * @param n2
 * @returns {*}
 */
Math.complementation = function (n1, n2) {
    if (Number.isNumber(n1) && Number.isNumber(n2)) {
        return (n1-0) % (n2-0);
    }
    return null;
};


String.isEmpty = function (s) {
    return s === "";
};


/**
 * 字符串拼接
 * @param s1
 * @param s2
 * @returns {*}
 */
String.concat = function (s1, s2) {
    if (Object.isValid(s1) && Object.isValid(s2)) {
        s1 += "", s2 += "";
        return s1 + s2;
    }
    return null;
};


